//Defining class FrameASM
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Assembly Studio for MVS
 * Copyright 2004 Frdric Brown
 */
/*
 *  This file is part of Assembly Studio for MVS.
 *
 *  Assembly Studio for MVS is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Assembly Studio for MVS is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with Assembly Studio for MVS; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
//Import the class moka.lang.System
//Import the class moka.lang.String
//Import the class moka.x.Frame
//Import the class moka.x.Frame
//Import the class moka.x.Frame
/**
 *
 *
 * @author  Frdric Brown
 */
TFrameASM * TFrameASM0 ( ) {
	TFrameASM * this = malloc ( sizeof ( TFrameASM ) ) ; 
	this -> class = ( char * ) "FrameASM" ; 
	this -> class_id = 12 ; 
	this -> super = ( void * ) Frame ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	//Methods from class EventListener
	//Methods from class Component
	this -> setBounds_short_int_short_int_short_int_short_int = ( void * ) TComponent_setBounds_short_int_short_int_short_int_short_int ; 
	this -> setY_short_int = ( void * ) TComponent_setY_short_int ; 
	this -> move_short_int_short_int = ( void * ) TComponent_move_short_int_short_int ; 
	this -> center_ = ( void * ) TComponent_center_ ; 
	//Methods from class Container
	this -> onPaint_ = ( void * ) TContainer_onPaint_ ; 
	this -> onRefresh_ = ( void * ) TContainer_onRefresh_ ; 
	this -> repaintChildren_ = ( void * ) TContainer_repaintChildren_ ; 
	this -> paintChildren_SCR_RECT_p = ( void * ) TContainer_paintChildren_SCR_RECT_p ; 
	this -> checkMnemonic_char = ( void * ) TContainer_checkMnemonic_char ; 
	this -> add_Component = ( void * ) TContainer_add_Component ; 
	this -> remove_Component = ( void * ) TContainer_remove_Component ; 
	this -> toFront_Component = ( void * ) TContainer_toFront_Component ; 
	this -> clean_ = ( void * ) TContainer_clean_ ; 
	//Methods from class Frame
	this -> finalize_ = ( void * ) TFrame_finalize_ ; 
	this -> use_ = ( void * ) TFrame_use_ ; 
	this -> isCursorOverCloseButton_short_int_short_int = ( void * ) TFrame_isCursorOverCloseButton_short_int_short_int ; 
	this -> isCursorOverMinimizeButton_short_int_short_int = ( void * ) TFrame_isCursorOverMinimizeButton_short_int_short_int ; 
	this -> isCursorOverTitleBar_short_int_short_int = ( void * ) TFrame_isCursorOverTitleBar_short_int_short_int ; 
	this -> onClose_ = ( void * ) TFrame_onClose_ ; 
	this -> onMinimize_ = ( void * ) TFrame_onMinimize_ ; 
	this -> onDrag_ = ( void * ) TFrame_onDrag_ ; 
	this -> dispose_ = ( void * ) TFrame_dispose_ ; 
	this -> setVisible_BOOL = ( void * ) TFrame_setVisible_BOOL ; 
	this -> paint_ = ( void * ) TFrame_paint_ ; 
	this -> paintForeground_ = ( void * ) TFrame_paintForeground_ ; 
	this -> isCursorOver_short_int_short_int = ( void * ) TFrame_isCursorOver_short_int_short_int ; 
	this -> setCaption_String = ( void * ) TFrame_setCaption_String ; 
	this -> setFont_short_int = ( void * ) TFrame_setFont_short_int ; 
	//Methods from class FrameASM
	this -> eventTriggered_Object = ( void * ) TFrameASM_eventTriggered_Object ; 
	this -> setASMFromCode_String = ( void * ) TFrameASM_setASMFromCode_String ; 
	return this ; 
} 

TFrameASM * TFrameASM_GuiASM ( struct GuiASM * frameCode ) {
	TFrameASM * this = TFrameASM0 ( ) ; 
	FrameASM__GuiASM ( this , frameCode ) ; 
	return this ; 
} 
void FrameASM__GuiASM ( struct FrameASM * this , struct GuiASM * frameCode ) { 
	Frame__String ( ( TFrame *  ) this , TString_char_p ( ( char * ) "Assembler" ) ) ; 
	if ( System_CALCULATOR ) { 
		this -> setBounds_short_int_short_int_short_int_short_int ( this , 0 , 0 , 200 , 100 ) ; 
		
	} 
	else { 
		this -> setBounds_short_int_short_int_short_int_short_int ( this , 0 , 0 , 120 , 90 ) ; 
		
	} 
	this -> defaultCloseOperation = Frame_HIDE_ON_CLOSE ; 
	this -> txtASM = TTextArea_ ( ) ; 
	if ( System_CALCULATOR ) { 
		this -> txtASM -> setBounds_short_int_short_int_short_int_short_int ( this -> txtASM , 5 , 15 , 190 , 60 ) ; 
		
	} 
	else { 
		this -> txtASM -> setBounds_short_int_short_int_short_int_short_int ( this -> txtASM , 5 , 15 , 110 , 50 ) ; 
		
	} 
	this -> txtASM -> warp = FALSE ; 
	this -> txtASM -> vScrollVisible = TRUE ; 
	this -> add_Component ( this , this -> txtASM ) ; 
	this -> btnASM = TButton_String ( TString_char_p ( ( char * ) "ASM" ) ) ; 
	this -> btnASM -> setBounds_short_int_short_int_short_int_short_int ( this -> btnASM , 5 , this -> height - 20 , 40 , 15 ) ; 
	this -> btnASM -> mnemonic = 'A' ; 
	this -> btnASM -> listen = this ; 
	this -> add_Component ( this , this -> btnASM ) ; 
	this -> frameCode = frameCode ; 
	
} 

void TFrameASM_eventTriggered_Object ( struct FrameASM * this , struct Object * sender ) { 
	if ( sender == this -> btnASM ) { 
		this -> frameCode -> setCodeFromASM_String ( this -> frameCode , this -> txtASM -> caption ) ; 
		this -> frameCode -> setVisible_BOOL ( this -> frameCode , TRUE ) ; 
		GEM_gem -> toFront_Component ( GEM_gem , this -> frameCode ) ; 
		
	} 
	
} 

void TFrameASM_setASMFromCode_String ( struct FrameASM * this , struct String * code ) { 
	TString *  codeASM = TString_char_p ( ( char * ) "" ) ; 
	char * exprP = code -> value ; 
	char * endP = &exprP[strlen(exprP)];
		 unsigned byte opCode ; 
	while ( exprP < endP ) { 
		opCode = DisASM_getByte_char_p_short_int ( exprP , 8 ) ; 
		exprP += 2 ; 
		if ( opCode < 0x40 ) { 
			if ( ( exprP + 2 ) > endP ) { 
				break ; 
				
			} 
			
		} 
		else if ( opCode < 0xC0 ) { 
			if ( ( exprP + 6 ) > endP ) { 
				break ; 
				
			} 
			
		} 
		else { 
			if ( ( exprP + 10 ) > endP ) { 
				break ; 
				
			} 
			
		} 
		if ( DisASM_opVecStr [ opCode ] ) { 
			codeASM -> append_String ( codeASM , DisASM_opVecForm [ opCode ] -> print_unsigned_byte_char_p ( DisASM_opVecForm [ opCode ] , opCode , exprP ) ) ; 
			codeASM -> append_char ( codeASM , '\n' ) ; 
			
		} 
		else { 
			codeASM -> append_String ( codeASM , TString_char_p ( ( char * ) "OpCode inconnu : 0x" ) ) ; 
			codeASM -> append_String ( codeASM , DisASM_printHex8_unsigned_byte ( opCode ) ) ; 
			codeASM -> append_char ( codeASM , '\n' ) ; 
			
		} 
		if ( opCode < 0x40 ) { 
			exprP += 2 ; 
			
		} 
		else if ( opCode < 0xC0 ) { 
			exprP += 6 ; 
			
		} 
		else { 
			exprP += 10 ; 
			
		} 
		
	} 
	this -> txtASM -> setCaption_String ( this -> txtASM , codeASM ) ; 
	
} 
