//Defining class GuiASM
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Assembly Studio for MVS
 * Copyright 2004 Frdric Brown
 */
/*
 *  This file is part of Assembly Studio for MVS.
 *
 *  Assembly Studio for MVS is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Assembly Studio for MVS is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with Assembly Studio for MVS; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * This class is the main class of Assembly Studio for MVS.
 *
 * @author  Frdric Brown
 */
TGuiASM * TGuiASM0 ( ) {
	TGuiASM * this = malloc ( sizeof ( TGuiASM ) ) ; 
	this -> class = ( char * ) "GuiASM" ; 
	this -> class_id = 0 ; 
	this -> super = ( void * ) Frame ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	//Methods from class EventListener
	//Methods from class Component
	this -> setBounds_short_int_short_int_short_int_short_int = ( void * ) TComponent_setBounds_short_int_short_int_short_int_short_int ; 
	this -> setY_short_int = ( void * ) TComponent_setY_short_int ; 
	this -> move_short_int_short_int = ( void * ) TComponent_move_short_int_short_int ; 
	this -> center_ = ( void * ) TComponent_center_ ; 
	//Methods from class Container
	this -> onPaint_ = ( void * ) TContainer_onPaint_ ; 
	this -> onRefresh_ = ( void * ) TContainer_onRefresh_ ; 
	this -> repaintChildren_ = ( void * ) TContainer_repaintChildren_ ; 
	this -> paintChildren_SCR_RECT_p = ( void * ) TContainer_paintChildren_SCR_RECT_p ; 
	this -> checkMnemonic_char = ( void * ) TContainer_checkMnemonic_char ; 
	this -> add_Component = ( void * ) TContainer_add_Component ; 
	this -> remove_Component = ( void * ) TContainer_remove_Component ; 
	this -> toFront_Component = ( void * ) TContainer_toFront_Component ; 
	this -> clean_ = ( void * ) TContainer_clean_ ; 
	//Methods from class Frame
	this -> finalize_ = ( void * ) TFrame_finalize_ ; 
	this -> use_ = ( void * ) TFrame_use_ ; 
	this -> isCursorOverCloseButton_short_int_short_int = ( void * ) TFrame_isCursorOverCloseButton_short_int_short_int ; 
	this -> isCursorOverMinimizeButton_short_int_short_int = ( void * ) TFrame_isCursorOverMinimizeButton_short_int_short_int ; 
	this -> isCursorOverTitleBar_short_int_short_int = ( void * ) TFrame_isCursorOverTitleBar_short_int_short_int ; 
	this -> onClose_ = ( void * ) TFrame_onClose_ ; 
	this -> onMinimize_ = ( void * ) TFrame_onMinimize_ ; 
	this -> onDrag_ = ( void * ) TFrame_onDrag_ ; 
	this -> dispose_ = ( void * ) TFrame_dispose_ ; 
	this -> setVisible_BOOL = ( void * ) TFrame_setVisible_BOOL ; 
	this -> paint_ = ( void * ) TFrame_paint_ ; 
	this -> paintForeground_ = ( void * ) TFrame_paintForeground_ ; 
	this -> isCursorOver_short_int_short_int = ( void * ) TFrame_isCursorOver_short_int_short_int ; 
	this -> setCaption_String = ( void * ) TFrame_setCaption_String ; 
	this -> setFont_short_int = ( void * ) TFrame_setFont_short_int ; 
	//Methods from class GuiASM
	this -> eventTriggered_Object = ( void * ) TGuiASM_eventTriggered_Object ; 
	this -> setCodeFromASM_String = ( void * ) TGuiASM_setCodeFromASM_String ; 
	return this ; 
} 

TGuiASM * TGuiASM_ ( ) {
	TGuiASM * this = TGuiASM0 ( ) ; 
	GuiASM__ ( this ) ; 
	return this ; 
} 
void GuiASM__ ( struct GuiASM * this ) { 
	Frame__String ( ( TFrame *  ) this , TString_char_p ( ( char * ) "Machine code" ) ) ; 
	if ( System_CALCULATOR ) { 
		this -> setBounds_short_int_short_int_short_int_short_int ( this , 0 , 0 , 200 , 100 ) ; 
		
	} 
	else { 
		this -> setBounds_short_int_short_int_short_int_short_int ( this , 0 , 0 , 120 , 90 ) ; 
		
	} 
	this -> defaultCloseOperation = Frame_HIDE_ON_CLOSE ; 
	this -> btnDis = TButton_String ( TString_char_p ( ( char * ) "DeASM" ) ) ; 
	this -> btnDis -> setBounds_short_int_short_int_short_int_short_int ( this -> btnDis , 5 , this -> height - 20 , 40 , 15 ) ; 
	this -> btnDis -> mnemonic = 'D' ; 
	this -> btnDis -> listen = this ; 
	this -> add_Component ( this , this -> btnDis ) ; 
	this -> txtCode = TTextArea_ ( ) ; 
	if ( System_CALCULATOR ) { 
		this -> txtCode -> setBounds_short_int_short_int_short_int_short_int ( this -> txtCode , 5 , 15 , 190 , 60 ) ; 
		
	} 
	else { 
		this -> txtCode -> setBounds_short_int_short_int_short_int_short_int ( this -> txtCode , 5 , 15 , 110 , 50 ) ; 
		
	} 
	this -> txtCode -> warp = FALSE ; 
	this -> txtCode -> vScrollVisible = TRUE ; 
	this -> add_Component ( this , this -> txtCode ) ; 
	this -> frameASM = TFrameASM_GuiASM ( this ) ; 
	this -> frameAbout = TFrameAbout_ ( ) ; 
	this -> bar = TMenuBar_ ( ) ; 
	this -> bar -> setBounds_short_int_short_int_short_int_short_int ( this -> bar , 0 , 0 , GEM_LCD_WIDTH - 2 , 15 ) ; 
	GEM_gem -> add_Component ( GEM_gem , this -> bar ) ; 
	this -> mFile = TMenu_String ( TString_char_p ( ( char * ) "File" ) ) ; 
	this -> mFile -> mnemonic = 'F' ; 
	this -> bar -> add_Menu ( this -> bar , this -> mFile ) ; 
	this -> itmOpenASM = TMenuItem_String ( TString_char_p ( ( char * ) "Import ASM" ) ) ; 
	this -> itmOpenASM -> mnemonic = 'M' ; 
	this -> itmOpenASM -> listen = this ; 
	this -> mFile -> add_MenuItem ( this -> mFile , this -> itmOpenASM ) ; 
	this -> itmSaveASM = TMenuItem_String ( TString_char_p ( ( char * ) "Export ASM" ) ) ; 
	this -> itmSaveASM -> mnemonic = 'X' ; 
	this -> itmSaveASM -> listen = this ; 
	this -> mFile -> add_MenuItem ( this -> mFile , this -> itmSaveASM ) ; 
	this -> itmOpenBIN = TMenuItem_String ( TString_char_p ( ( char * ) "Import code" ) ) ; 
	this -> itmOpenBIN -> mnemonic = 'I' ; 
	this -> itmOpenBIN -> listen = this ; 
	this -> mFile -> add_MenuItem ( this -> mFile , this -> itmOpenBIN ) ; 
	this -> itmSaveBIN = TMenuItem_String ( TString_char_p ( ( char * ) "Export code" ) ) ; 
	this -> itmSaveBIN -> mnemonic = 'E' ; 
	this -> itmSaveBIN -> listen = this ; 
	this -> mFile -> add_MenuItem ( this -> mFile , this -> itmSaveBIN ) ; 
	this -> itmQuit = TMenuItem_String ( TString_char_p ( ( char * ) "Quit" ) ) ; 
	this -> itmQuit -> mnemonic = 'Q' ; 
	this -> itmQuit -> listen = this ; 
	this -> mFile -> add_MenuItem ( this -> mFile , this -> itmQuit ) ; 
	this -> mView = TMenu_String ( TString_char_p ( ( char * ) "View" ) ) ; 
	this -> mView -> mnemonic = 'V' ; 
	this -> bar -> add_Menu ( this -> bar , this -> mView ) ; 
	this -> itmCode = TMenuItem_String ( TString_char_p ( ( char * ) "Machine code" ) ) ; 
	this -> itmCode -> mnemonic = 'M' ; 
	this -> itmCode -> listen = this ; 
	this -> mView -> add_MenuItem ( this -> mView , this -> itmCode ) ; 
	this -> itmASM = TMenuItem_String ( TString_char_p ( ( char * ) "Assembler" ) ) ; 
	this -> itmASM -> mnemonic = 'A' ; 
	this -> itmASM -> listen = this ; 
	this -> mView -> add_MenuItem ( this -> mView , this -> itmASM ) ; 
	this -> mHelp = TMenu_String ( TString_char_p ( ( char * ) "Help" ) ) ; 
	this -> mHelp -> mnemonic = 'H' ; 
	this -> bar -> add_Menu ( this -> bar , this -> mHelp ) ; 
	this -> itmAbout = TMenuItem_String ( TString_char_p ( ( char * ) "About..." ) ) ; 
	this -> itmAbout -> mnemonic = 'A' ; 
	this -> itmAbout -> listen = this ; 
	this -> mHelp -> add_MenuItem ( this -> mHelp , this -> itmAbout ) ; 
	GEM_gem -> add_Component ( GEM_gem , this ) ; 
	GEM_gem -> add_Component ( GEM_gem , this -> frameASM ) ; 
	GEM_gem -> add_Component ( GEM_gem , this -> frameAbout ) ; 
	this -> frameAbout -> center_ ( this -> frameAbout ) ; 
	
} 

void TGuiASM_eventTriggered_Object ( struct GuiASM * this , struct Object * sender ) { 
	TFile *  f ; 
	TString *  s ; 
	char c ; 
	char * str ; 
	if ( sender == this -> btnDis ) { 
		this -> frameASM -> setASMFromCode_String ( this -> frameASM , this -> txtCode -> caption ) ; 
		this -> frameASM -> setVisible_BOOL ( this -> frameASM , TRUE ) ; 
		GEM_gem -> toFront_Component ( GEM_gem , this -> frameASM ) ; 
		
	} 
	else if ( sender == this -> itmQuit ) { 
		GEM_gem -> setStarted_BOOL ( GEM_gem , FALSE ) ; 
		
	} 
	else if ( sender == this -> itmCode ) { 
		this -> setVisible_BOOL ( this , TRUE ) ; 
		GEM_gem -> toFront_Component ( GEM_gem , this ) ; 
		
	} 
	else if ( sender == this -> itmASM ) { 
		this -> frameASM -> setVisible_BOOL ( this -> frameASM , TRUE ) ; 
		GEM_gem -> toFront_Component ( GEM_gem , this -> frameASM ) ; 
		
	} 
	else if ( sender == this -> itmAbout ) { 
		this -> frameAbout -> setVisible_BOOL ( this -> frameAbout , TRUE ) ; 
		GEM_gem -> toFront_Component ( GEM_gem , this -> frameAbout ) ; 
		
	} 
	else if ( sender == this -> itmOpenASM || sender == this -> itmOpenBIN ) { 
		f = File_showVarLinkDialog_ ( ) ; 
		if ( f ) { 
			f -> open_short_int ( f , File_MODE_OPEN_READ_TEXT ) ; 
			if ( f -> error ) { 
				f -> finalize_ ( f ) ; 
				return ; 
				
			} 
			str = System_malloc_long_int ( sizeof ( char ) * ( 4096 ) ) ; 
			str [ f -> readBytesCount_char_p_short_int ( f , str , f -> available_ ( f ) ) ] = '\0' ; 
			s = TString_char_p_BOOL ( str , FALSE ) ; 
			if ( sender == this -> itmOpenASM ) { 
				this -> frameASM -> txtASM -> setCaption_String ( this -> frameASM -> txtASM , s ) ; 
				this -> frameASM -> setVisible_BOOL ( this -> frameASM , TRUE ) ; 
				GEM_gem -> toFront_Component ( GEM_gem , this -> frameASM ) ; 
				
			} 
			else { 
				this -> txtCode -> setCaption_String ( this -> txtCode , s ) ; 
				this -> setVisible_BOOL ( this , TRUE ) ; 
				GEM_gem -> toFront_Component ( GEM_gem , this ) ; 
				
			} 
			f -> finalize_ ( f ) ; 
			
		} 
		
	} 
	else if ( sender == this -> itmSaveASM || sender == this -> itmSaveBIN ) { 
		s = OptionPane_showInputDialog_String ( TString_char_p ( ( char * ) "File name" ) ) ; 
		if ( s ) { 
			f = TFile_String ( s ) ; 
			f -> open_short_int ( f , File_MODE_WRITE_TEXT ) ; 
			if ( ! f -> error ) { 
				if ( sender == this -> itmSaveASM ) { 
					f -> writeChars_char_p ( f , this -> frameASM -> txtASM -> caption -> value ) ; 
					
				} 
				else { 
					f -> writeChars_char_p ( f , this -> txtCode -> caption -> value ) ; 
					
				} 
				
			} 
			f -> finalize_ ( f ) ; 
			
		} 
		
	} 
	
} 

void TGuiASM_setCodeFromASM_String ( struct GuiASM * this , struct String * asmStr ) { 
	TString *  code = TString_char_p ( ( char * ) "" ) ; 
	char * exprP = asmStr -> value ; 
	char inst [ 25 ] ; 
	short int i ; 
	while ( * exprP ) { 
		while ( ( ( * exprP == ' ' ) || ( * exprP == '\n' ) ) && * exprP ) exprP ++ ; 
		for ( i = 0 ; 
		exprP [ 0 ] != ' ' && exprP [ 0 ] != '\n' && exprP [ 0 ] ; 
		i ++ ) { 
			inst [ i ] = * exprP ++ ; 
			
		} 
		if ( i > 0 ) { 
			inst [ i ] = '\0' ; 
			i = DisASM_trouverIndex_char_p ( inst ) ; 
			if ( i >= 0 ) { 
				code -> append_String ( code , DisASM_opVecForm [ i ] -> assemble_unsigned_byte_char_p ( DisASM_opVecForm [ i ] , ( unsigned byte ) i , exprP ) ) ; 
				
			} 
			
		} 
		while ( * exprP != '\n' && * exprP ) exprP ++ ; 
		
	} 
	this -> txtCode -> setCaption_String ( this -> txtCode , code ) ; 
	
} 

void GuiASM_main_ ( ) { 
	GEM_gem -> setFont_short_int ( GEM_gem , Font_FONT_6x8 ) ; 
	System_clrscr_ ( ) ; 
	GEM_gem -> setBackground_ ( GEM_gem ) ; 
	TGuiASM *  f = TGuiASM_ ( ) ; 
	
} 
