//Defining class FrameAbout
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Assembly Studio for MVS
 * Copyright 2004 Frdric Brown
 */
/*
 *  This file is part of Assembly Studio for MVS.
 *
 *  Assembly Studio for MVS is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Assembly Studio for MVS is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with Assembly Studio for MVS; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
//Import the class moka.lang.System
//Import the class moka.lang.String
//Import the class moka.x.Frame
//Import the class moka.x.Frame
//Import the class moka.x.Frame
//Import the class moka.x.Frame
/**
 *
 *
 * @author  Frdric Brown
 */
TFrameAbout * TFrameAbout0 ( ) {
	TFrameAbout * this = malloc ( sizeof ( TFrameAbout ) ) ; 
	this -> class = ( char * ) "FrameAbout" ; 
	this -> class_id = 11 ; 
	this -> super = ( void * ) Frame ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	//Methods from class EventListener
	//Methods from class Component
	this -> setBounds_short_int_short_int_short_int_short_int = ( void * ) TComponent_setBounds_short_int_short_int_short_int_short_int ; 
	this -> setY_short_int = ( void * ) TComponent_setY_short_int ; 
	this -> move_short_int_short_int = ( void * ) TComponent_move_short_int_short_int ; 
	this -> center_ = ( void * ) TComponent_center_ ; 
	//Methods from class Container
	this -> onPaint_ = ( void * ) TContainer_onPaint_ ; 
	this -> onRefresh_ = ( void * ) TContainer_onRefresh_ ; 
	this -> repaintChildren_ = ( void * ) TContainer_repaintChildren_ ; 
	this -> paintChildren_SCR_RECT_p = ( void * ) TContainer_paintChildren_SCR_RECT_p ; 
	this -> checkMnemonic_char = ( void * ) TContainer_checkMnemonic_char ; 
	this -> add_Component = ( void * ) TContainer_add_Component ; 
	this -> remove_Component = ( void * ) TContainer_remove_Component ; 
	this -> toFront_Component = ( void * ) TContainer_toFront_Component ; 
	this -> clean_ = ( void * ) TContainer_clean_ ; 
	//Methods from class Frame
	this -> finalize_ = ( void * ) TFrame_finalize_ ; 
	this -> use_ = ( void * ) TFrame_use_ ; 
	this -> isCursorOverCloseButton_short_int_short_int = ( void * ) TFrame_isCursorOverCloseButton_short_int_short_int ; 
	this -> isCursorOverMinimizeButton_short_int_short_int = ( void * ) TFrame_isCursorOverMinimizeButton_short_int_short_int ; 
	this -> isCursorOverTitleBar_short_int_short_int = ( void * ) TFrame_isCursorOverTitleBar_short_int_short_int ; 
	this -> onClose_ = ( void * ) TFrame_onClose_ ; 
	this -> onMinimize_ = ( void * ) TFrame_onMinimize_ ; 
	this -> onDrag_ = ( void * ) TFrame_onDrag_ ; 
	this -> dispose_ = ( void * ) TFrame_dispose_ ; 
	this -> setVisible_BOOL = ( void * ) TFrame_setVisible_BOOL ; 
	this -> paint_ = ( void * ) TFrame_paint_ ; 
	this -> paintForeground_ = ( void * ) TFrame_paintForeground_ ; 
	this -> isCursorOver_short_int_short_int = ( void * ) TFrame_isCursorOver_short_int_short_int ; 
	this -> setCaption_String = ( void * ) TFrame_setCaption_String ; 
	this -> setFont_short_int = ( void * ) TFrame_setFont_short_int ; 
	//Methods from class FrameAbout
	this -> eventTriggered_Object = ( void * ) TFrameAbout_eventTriggered_Object ; 
	return this ; 
} 

TFrameAbout * TFrameAbout_ ( ) {
	TFrameAbout * this = TFrameAbout0 ( ) ; 
	FrameAbout__ ( this ) ; 
	return this ; 
} 
void FrameAbout__ ( struct FrameAbout * this ) { 
	Frame__String ( ( TFrame *  ) this , TString_char_p ( ( char * ) "ASM Studio" ) ) ; 
	this -> setBounds_short_int_short_int_short_int_short_int ( this , 0 , 0 , 120 , 90 ) ; 
	this -> defaultCloseOperation = Frame_HIDE_ON_CLOSE ; 
	this -> txtAbout = TTextArea_ ( ) ; 
	this -> txtAbout -> setBounds_short_int_short_int_short_int_short_int ( this -> txtAbout , 5 , 15 , 110 , 50 ) ; 
	this -> txtAbout -> warp = FALSE ; 
	this -> txtAbout -> font = Font_FONT_4x6 ; 
	this -> txtAbout -> setCaption_String ( this -> txtAbout , TString_char_p ( ( char * ) "//FB1ABOUT JOB\n//CREDITS PGM=AUTHOR\n//SYSIN DD *\n  Frdric Brown\n  (c) 2004 Qusoft\n           microsystmes\n/*" ) ) ; 
	this -> txtAbout -> enabled = FALSE ; 
	this -> add_Component ( this , this -> txtAbout ) ; 
	this -> btnOk = TButton_String ( TString_char_p ( ( char * ) "Ok" ) ) ; 
	this -> btnOk -> mnemonic = 'O' ; 
	this -> btnOk -> listen = this ; 
	this -> add_Component ( this , this -> btnOk ) ; 
	this -> btnOk -> setBounds_short_int_short_int_short_int_short_int ( this -> btnOk , 0 , 0 , 20 , 15 ) ; 
	this -> btnOk -> center_ ( this -> btnOk ) ; 
	this -> btnOk -> setY_short_int ( this -> btnOk , this -> height - 20 ) ; 
	
} 

void TFrameAbout_eventTriggered_Object ( struct FrameAbout * this , struct Object * sender ) { 
	if ( sender == this -> btnOk ) { 
		this -> setVisible_BOOL ( this , FALSE ) ; 
		
	} 
	
} 
